# %% imports
import pandas as pd

# %% read data
df = pd.read_csv(
    "trigger_results.csv",
    names=[
        "py_ver",
        "trans_ver",
        "states",
        "time",
        "stddev",
    ],
    dtype={
        "py_ver": str,
        "trans_ver": str,
        "states": int,
        "time": float,
        "stddev": float,
    },
)

# %% plot init time vs states

p = df[df["trans_ver"] == "0.9.1"]
p1 = pd.DataFrame(
    {k: p[p["py_ver"] == k]["time"].values for k in sorted(p.py_ver.unique())},
    index=p[p["py_ver"] == "3.12"]["states"].values,
)
p1.plot.bar(
    title="Model state change transitions 0.9.1 (cycle n models through n states)",
    xlabel="Number of states (n)",
    ylabel="Time (ms)",
)

# %% plot init time vs states

p = df[df["py_ver"] == "3.12"]
p1 = pd.DataFrame(
    {k: p[p["trans_ver"] == k]["time"].values for k in sorted(p.trans_ver.unique())},
    index=p[p["trans_ver"] == "0.9.0"]["states"].values,
)
p1.plot.bar(
    title="Model state change Python 3.12 (cycle n models through n states)",
    xlabel="Number of states",
    ylabel="Time (ms)",
)
# %%
