#!/bin/bash

# Usage: bash run_test.sh test_init.py (or test_enum.py, ...)
# Create conda with different python versions first!
# conda create -n test-3.12 python=3.12
# conda create -n test-3.11 python=3.11
# conda create -n test-3.10 python=3.10
envs=("test-3.12" "test-3.11" "test-3.10")
versions=("transitions==0.7.2" "transitions==0.8.0" "transitions==0.8.11" "transitions==0.9.0" "git+https://github.com/pytransitions/transitions")

. /opt/homebrew/Caskroom/miniconda/base/etc/profile.d/conda.sh
for env in ${envs[@]}; do
	conda activate ${env};
	for version in ${versions[@]}; do
		echo "Testing transitions version ${version} in ${env}";
		pip install ${version};
		python $1;
	done;
	conda deactivate
done;
